'' ******************************************************************************
'' * CMPS03 Object                                                              *
'' * Tim Moore May 08                                                           *
'' * Version 1.0                                                                *
'' ******************************************************************************
''
'' this object provides the PUBLIC functions:
''  -> getSwVersion  - read register 0 - the device revision
''  -> getBearing
''
'' this object provides the PRIVATE functions:
''  -> None
''
'' this object uses the following sub OBJECTS:
''  -> i2cObject
''
'' Revision History:
''  -> V1
''
'' CMP03 from Devantech Ltd - http://www.robotelectronics.co.uk 
''
'' Default address is %1100_0000


CON
  _CMPS_CmdReg    = 0
  _CMPS_SwReg     = 0  
  _CMPS_Bearing   = 2


OBJ
  i2cObject   : "basic_i2c_driver" 

VAR
  WORD CMPS_Bearing
    
PUB getSwVersion(i2cSCL,_deviceAddress) : version
  ' read the CMPS's version register
  version := i2cObject.readLocation(i2cSCL,_deviceAddress, _CMPS_SwReg)
  return version

PUB getBearing(i2cSCL,_deviceAddress) : result
  ' return the last Bearing
  i2cObject.Start(i2cSCL)
  i2cObject.Write(i2cSCL,_deviceAddress | 0)
  i2cObject.Write(i2cSCL,2)
  i2cObject.Start(i2cSCL)
  i2cObject.Write(i2cSCL,_deviceAddress | 1)
  CMPS_Bearing := i2cObject.Read(i2cSCL,i2cObject#ACK)
  CMPS_Bearing <<= 8
  CMPS_Bearing := CMPS_Bearing + i2cObject.Read(i2cSCL,i2cObject#NAK)
  i2cObject.Stop(i2cSCL)
      
  return (CMPS_Bearing)

   